<style type="text/css">
  .task-adv-1 {
    color: #f00;
    margin: 3px;
  }
  .task-adv-2 {
    color: #f90;
    margin: 3px;
  }
  .task-adv-3 {
    color: #e0df0b;
    margin: 3px;
  }
  .task-adv-4 {
    color: #0a0;
    margin: 3px;
  }

  .bandeau-tasks {
    /*background-color: #ccc;
    width: 100%;*/
    color: #ccc;
    font-weight: bold;
    font-size: large;
  }

  /*.modal-dialog {
    max-width: 800px;
    width: 800px;
  }*/
</style>

<div class="modal-header">
  <h5 class="modal-title" id="exampleModalLabel"><%= @modal_title.nil? ? "Action" : @modal_title %></h5>
  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
</div>

<%= simple_form_for @tools_task, remote: true,
    wrapper: :horizontal_form,
    wrapper_mappings: {
      boolean:       :horizontal_boolean,
      check_boxes:   :horizontal_collection,
      date:          :horizontal_multi_select,
      datetime:      :horizontal_multi_select,
      file:          :horizontal_file,
      radio_buttons: :horizontal_collection,
      range:         :horizontal_range,
      time:          :horizontal_multi_select
    } do |f| %>
  <div class="modal-body" id='task-form'>
    <%#= f.error_notification %>
    <%#= f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present? %>
    <% if @tools_task.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@tools_task.errors.count, "error") %> prohibited this task from being saved:</h2>

        <ul>
        <% @tools_task.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
        </ul>
      </div>
    <% end %>

    <%= f.hidden_field :rca_id %>
    <%= f.hidden_field :tool_reference %>
    <%= f.hidden_field :tool_num %>

    <!-- WHY ? -->
    <div class='bandeau-tasks'>WHY ?</div>

    <div class="form-group row">
      <%= f.label :tools_cause_select, t('.tools_cause_select'), class: 'col-sm-3 col-form-label select required' %>
      <% causes, causes_colors = causes_with_colors(@tools_task.rca, @tools_task.tool_reference) %>
      <%= f.hidden_field :tools_cause_id %>
      <%#= helper_causes_list(causes, 'tools_task', 'tools_cause_select', @tools_task.tools_cause_id, causes_colors, 'disabled') %>
      <div class='col-sm-9'>
        <%= helper_causes_list(causes, 'tools_task', 'tools_cause_select',
                               {selected: @tools_task.tools_cause_id, colors: causes_colors, disable: 'disabled'}) %>
      </div>
    </div>

    <% if @tools_task.task_detail_type && @tools_task.task_detail_type != '' %>
      <%= f.hidden_field :task_detail_type %>
    <% else %>
      <% task_detail_types = @step_tool&.tool_options&.[](:task_options)&.[](:task_detail_type)
         task_detail_types ||= []
      %>
      <%= f.input :task_detail_type, collection: task_types_collection(task_detail_types) %>
    <% end %>

    <!-- WHAT ? -->
    <hr><div class='bandeau-tasks'>WHAT ?</div>

    <%= f.input :name, autofocus: true, html5: true %>

    <div class="form-group row">
      <%= f.label :parent_id, class: 'col-sm-3 col-form-label select required' %>
      <% actions = Tools::TaskQuery.relation.tasks_subtree_by_task_infos(@tools_task) %>
      <%#= helper_causes_list(actions, 'tools_task', 'parent_id', @tools_task.parent_id, nil, '', true) %>
      <div class='col-sm-9'>
        <%= helper_causes_list(actions, 'tools_task', 'parent_id',
                               {selected: @tools_task.parent_id, add_empty: true}) %>
      </div>
    </div>

    <!-- WHEN ? -->
    <hr><div class='bandeau-tasks'>WHEN ?</div>

    <%= f.input :created_at, as: :date, html5: true %>
    <div id="date-due-reschedule">
      <%#= task_date_due_reschedule_helper_form(@tools_task) %>
      <%= render partial: 'reschedule_list', locals: {task: @tools_task} %>
    </div>
    <%#= f.input :date_due, as: :date, html5: true  %>
    <div class="form-group row">
      <%= f.label :date_due, class: 'col-sm-3 col-form-label select' %>
      <div id="task-due-<%=@tools_task.id%>" class='col-sm-9 d-flex flex-row justify-content-between align-items-center'>
        <%= f.date_field :date_due, html5: true, class: "form-control is-valid date optional" %>

        <%= reschedule_button(@tools_task) %>
      </div>
    </div>



    <%#= f.input :date_completion %>
    <%#= task_date_completion_helper(@tools_task).html_safe %>
    <div class="form-group row">
      <%= f.label :date_completion, class: 'col-sm-3 col-form-label select' %>
      <div id="task-completion-<%=@tools_task.id%>" class='col-sm-9 d-flex flex-row justify-content-between align-items-center'>
        <%#= hidden_field 'tools_task', :advancement %>
        <%=raw task_date_completion_helper_form(@tools_task) %>
      </div>
    </div>

    <!-- WHO ? -->
    <hr><div class='bandeau-tasks'>WHO ?</div>

    <%#= f.association :responsible_action %>
    <%#= f.association :responsible_rca %>

    <%#= form_person_helper(f, @tools_task, :responsible_action) %>
    <%#= form_person_helper(f, @tools_task, :responsible_rca) %>
    <%#= render partial: 'shared/form_person_helper', locals: {form: f, obj: @tools_task, column: 'responsible_action'} %>
    <div class="form-group row">
      <%= f.label :responsible_action, class: 'col-sm-3 col-form-label select' %>
      <div class='col-sm-9'>
        <%= helper_person_choose(@tools_task.responsible_action, 'tools_task', 'responsible_action') %>
      </div>
    </div>

    <div class="form-group row">
      <%= f.label :responsible_rca, class: 'col-sm-3 col-form-label select' %>
      <div class='col-sm-9'>
        <%= helper_person_choose(@tools_task.responsible_rca, 'tools_task', 'responsible_rca') %>
      </div>
    </div>

    <!-- HOW ? -->
    <hr><div class='bandeau-tasks'>HOW ?</div>

    <%#= f.input :advancement %>
    <div class="form-group row">
      <%= f.label :advancement, class: 'col-sm-3 col-form-label select' %>
      <div id="task-advance-<%=@tools_task.id%>" class='col-sm-9'>
        <%#= hidden_field 'tools_task', :advancement %>
        <%=raw task_advance_helper_form(@tools_task) %>
      </div>
    </div>
    <%= f.input :result %>
    <%= f.input :priority, collection: Tools::Task.priorities.symbolize_keys.keys %>

    <!-- TODO : écrire les partiels pour chaque type d'action s'il existe un modèle correspondant -->
    <% if @tools_task.task_detail %>
      <% sous_form = "form_#{@tools_task.task_detail_type.gsub('Tools::Task', '').downcase}" %>
      <%= render partial: sous_form, locals: {f: f} %>
    <% end %>

    <!-- Efficacity -->
    <% if @tools_task.matrix_stat %>
      <%= render partial: 'shared/form_matrix_stat', locals: {elem: @tools_task, f: f} %>
    <% end %>

    <!-- Efficacity -->
    <% if @tools_task.efficacity %>
      <%= render partial: 'shared/form_efficacity', locals: {elem: @tools_task, f: f} %>
    <% end %>
  </div>

  <div class="modal-footer">
    <div class="form-group">
    <%= f.submit class: "btn btn-warning" %>
    </div>
  </div>

<% end %>

<script text="javascript">
  $(function() {
    var update_disabled_cause = function(value) {
      console.log(value);
      $("#tools_task_tools_cause_select").attr('disabled', (value > 0)?true:false); // disabled / readonly
    }

    update_disabled_cause(<%= @tools_task.parent_id %>);

    $("#tools_task_parent_id").change(function(event) {
      console.log("parent changed!");
      console.log(this.value);

      let url = "<%= tools_task_get_cause_path %>"

      let datas = {};
      datas = {'id': this.value}
      $.ajax({
        url: url,
        type: 'GET',
        data: datas,
        dataType: 'json',
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
        success: function(data) {
          $("#tools_task_tools_cause_select").val(data['cause_id']);
          $("#tools_task_tools_cause_select").trigger('change');
          update_disabled_cause(data['cause_id'])
        }
      });
    });

    $("#tools_task_tools_cause_select").change(function(event) {
      $("#tools_task_tools_cause_id").val(this.value);
    });

    // var value_circle = ($('#circle').attr('data-circle'));
    // value_circle = value_circle / 4.0
    // console.log('Youhou!');
    // console.log(value_circle);

    // Options : https://github.com/kottenator/jquery-circle-progress
    $('.jquery-circle-p').circleProgress({
      // value: ($('#circle').attr('data-circle'))/4.0,
      // size: 30,
      // thickness: 11,
      // fill: {
      //   color: 'orange'
      //   // gradient: ["red", "green"]
      // },
      // emptyFill: 'orange',
      // animation: { duration: 1000 }
    });
  });
</script>
